## 파일 설명
| 파일명 | 파일 용도 | 관련 절 | 페이지 |
|:--   |:--      |:--    |:--      |
| and_gate.py | 단층 퍼셉트론으로 AND 게이트를 구현합니다. | 2.3.3 가중치와 편향 구현하기 | 53 |
| nand_gate.py | 단층 퍼셉트론으로 NAND 게이트를 구현합니다. | 2.3.3 가중치와 편향 구현하기 | 53 |
| or_gate.py | 단층 퍼셉트론으로 OR 게이트를 구현합니다. | 2.3.3 가중치와 편향 구현하기 | 53 |
| xor_gate.py | 2층 퍼셉트론으로 XOR 게이트를 구현합니다. | 2.5.2 XOR 게이트 구현하기 | 59 |

## 2장 퍼셉트론
이번 장에서는 퍼셉트론(_perceptron_) 알고리즘을 설명합니다. 퍼셉트론은 프랑크 로젠블라트(_Frank Rosenblatt_)가 1957년에 고안한 알고리즘입니다. 고대 화석 같은 이 알고리즘을 지금 시점에 왜 배우는가 하면, 퍼셉트론이 신경망(딥러닝)의 기원이 되는 알고리즘이기 때문입니다. 그래서 퍼셉트론의 구조를 배우는 것은 신경망과 딥러닝으로 나아가는 데 중요한 아이디어를 배우는 일도 됩니다.

이번 장에서는 퍼셉트론을 설명하고 퍼셉트론을 써서 간단한 문제를 풀어갑니다. 여정의 첫 목적지인 만큼 가볍고 즐거운 여행이 될 겁니다.

> **목차**
```
2.1 퍼셉트론이란? 
2.2 단순한 논리 회로 
__2.2.1 AND 게이트 
__2.2.2 NAND 게이트와 OR 게이트 
2.3 퍼셉트론 구현하기 
__2.3.1 간단한 구현부터 
__2.3.2 가중치와 편향 도입 
__2.3.3 가중치와 편향 구현하기 
2.4 퍼셉트론의 한계 
__2.4.1 도전! XOR 게이트 
__2.4.2 선형과 비선형 
2.5 다층 퍼셉트론이 출동한다면 
__2.5.1 기존 게이트 조합하기 
__2.5.2 XOR 게이트 구현하기 
2.6 NAND에서 컴퓨터까지
```

### 정리
이번 장에서는 퍼셉트론을 배웠습니다.  퍼셉트론은 간단한 알고리즘이라 그 구조를 쉽게 이해할 수 있습니다. 퍼셉트론은 다음 장에서 배울 신경망의 기초가 됩니다. 그러니 이번 장에서 배운 내용은 아주 중요합니다.

> **이번 장에서 배운 내용**
* 퍼셉트론은 입출력을 갖춘 알고리즘이다. 입력을 주면 정해진 규칙에 따른 값을 출력한다.
* 퍼셉트론에서는 ‘가중치’와 ‘편향’을 매개변수로 설정한다.
* 퍼셉트론으로 AND, OR 게이트 등의 논리 회로를 표현할 수 있다.
* XOR 게이트는 단층 퍼셉트론으로는 표현할 수 없다.
* 2층 퍼셉트론을 이용하면 XOR 게이트를 표현할 수 있다.
* 단층 퍼셉트론은 직선형 영역만 표현할 수 있고, 다층 퍼셉트론은 비선형 영역도 표현할 수 있다.
* 다층 퍼셉트론은 (이론상) 컴퓨터를 표현할 수 있다.
